package ru.dbotthepony.mc.otm.menu;

import net.minecraft.world.Container;
import net.minecraft.world.SimpleContainer;
import net.minecraft.world.entity.player.Inventory;
import net.minecraft.world.inventory.MenuType;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.level.block.entity.BlockEntity;
import ru.dbotthepony.mc.otm.Registry;
import ru.dbotthepony.mc.otm.block.entity.BlockEntityMatterReplicator;
import ru.dbotthepony.mc.otm.matter.MatterRegistry;
import ru.dbotthepony.mc.otm.menu.MatteryMenu;
import ru.dbotthepony.mc.otm.menu.slot.BatterySlot;
import ru.dbotthepony.mc.otm.menu.slot.MachineOutputSlot;
import ru.dbotthepony.mc.otm.menu.slot.SlotAutoRenderable;
import ru.dbotthepony.mc.otm.menu.widget.ProgressGaugeWidget;

import javax.annotation.Nullable;

public class MatterReplicatorMenu extends PoweredMatteryMenu {
	public MatterReplicatorMenu(int p_38852_, Inventory inventory) {
		this(p_38852_, inventory, null);
	}

	public MatterReplicatorMenu(int p_38852_, Inventory inventory, BlockEntityMatterReplicator tile) {
		super(Registry.Menus.MATTER_REPLICATOR, p_38852_, inventory, tile);

		Container container = tile != null ? tile.regular_slots : new SimpleContainer(3);

		for (int i = 0; i < container.getContainerSize(); i++)
			addSlot(new MachineOutputSlot(container, i, 64 + 18 * i, 38, true, false));

		if (tile != null) {
			new ProgressGaugeWidget<>(this, 38, 38, () -> (float) tile.getWorkProgress(), tile::cantProcessJob);
		} else {
			new ProgressGaugeWidget<>(this, 38, 38);
		}

		addBatterySlot();
		addInventorySlots();
	}

	@Override
	protected int getWorkingSlotStart() {
		return 0;
	}

	@Override
	protected int getWorkingSlotEnd() {
		return 7;
	}
}
