package ru.dbotthepony.mc.otm.network;

import net.minecraft.client.Minecraft;
import net.minecraftforge.fmllegacy.network.NetworkEvent;
import ru.dbotthepony.mc.otm.OverdriveThatMatters;
import ru.dbotthepony.mc.otm.menu.MatterPanelMenu;

import java.util.function.Supplier;

public class ClientPatternStateSendListPacketHandler {
	public static void handlePacket(PatternStateSendListPacket packet, Supplier<NetworkEvent.Context> context) {
		if (Minecraft.getInstance().player.containerMenu == null) {
			OverdriveThatMatters.LOGGER.error("Receive pattern state list for {}, but nothing is open!", packet.container_id);
			return;
		}

		if (Minecraft.getInstance().player.containerMenu.containerId != packet.container_id) {
			OverdriveThatMatters.LOGGER.error("Receive pattern state list for {}, but {} is open! ({})", packet.container_id, Minecraft.getInstance().player.containerMenu.containerId, Minecraft.getInstance().player.containerMenu);
			return;
		}

		if (!(Minecraft.getInstance().player.containerMenu instanceof MatterPanelMenu menu)) {
			OverdriveThatMatters.LOGGER.error("Receive pattern state list for {}, but it is wrong type!", packet.container_id);
			return;
		}

		menu.networkStates(packet.states);
	}
}
